'use strict';

var _objectWithoutProperties = require('babel-runtime/helpers/object-without-properties')['default'];

var _extends = require('babel-runtime/helpers/extends')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = Link;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouter = require('react-router');

/**
 * Link component which can infer href and children from page metadata.
 */

function Link(_ref) {
  var page = _ref.page;
  var to = _ref.to;
  var children = _ref.children;

  var props = _objectWithoutProperties(_ref, ['page', 'to', 'children']);

  to = to || page.path;
  children = children || page.title;
  return _react2['default'].createElement(
    _reactRouter.Link,
    _extends({}, props, { to: to }),
    children
  );
}

module.exports = exports['default'];
