'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _RenderRoot = require('./RenderRoot');

var _RenderRoot2 = _interopRequireDefault(_RenderRoot);

var _LinkRegistry = require('./LinkRegistry');

var _LinkRegistry2 = _interopRequireDefault(_LinkRegistry);

var _PageRegistry = require('./PageRegistry');

var _PageRegistry2 = _interopRequireDefault(_PageRegistry);

var Site = (function (_React$Component) {
  _inherits(Site, _React$Component);

  function Site() {
    _classCallCheck(this, Site);

    _get(Object.getPrototypeOf(Site.prototype), 'constructor', this).apply(this, arguments);
  }

  _createClass(Site, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var title = _props.title;
      var meta = _props.meta;
      var link = _props.link;
      var jsBundlePath = _props.jsBundlePath;
      var cssBundlePath = _props.cssBundlePath;
      var linkRegistry = _props.linkRegistry;
      var pageRegistry = _props.pageRegistry;

      return _react2['default'].createElement(
        'html',
        null,
        _react2['default'].createElement(
          'head',
          null,
          _react2['default'].createElement('meta', { charSet: 'utf8' }),
          title && _react2['default'].createElement(
            'title',
            null,
            title
          ),
          meta,
          link,
          _react2['default'].createElement(CSSBundle, { path: cssBundlePath })
        ),
        _react2['default'].createElement(
          'body',
          null,
          _react2['default'].createElement(_RenderRoot2['default'], { markup: children }),
          _react2['default'].createElement(_LinkRegistry2['default'].Render, { registry: linkRegistry }),
          _react2['default'].createElement(_PageRegistry2['default'].Render, { registry: pageRegistry }),
          _react2['default'].createElement(JSBundle, { path: jsBundlePath }),
          _react2['default'].createElement(StartSite, { path: jsBundlePath })
        )
      );
    }
  }], [{
    key: 'propTypes',
    value: {
      children: _react.PropTypes.node,

      jsBundlePath: _react.PropTypes.string,

      cssBundlePath: _react.PropTypes.string,

      title: _react.PropTypes.string,

      meta: _react.PropTypes.node,

      link: _react.PropTypes.node,

      linkRegistry: _react.PropTypes.object,

      pageRegistry: _react.PropTypes.object
    },
    enumerable: true
  }]);

  return Site;
})(_react2['default'].Component);

exports['default'] = Site;

function JSBundle(_ref) {
  var path = _ref.path;

  if (!path) {
    return _react2['default'].createElement('noscript', null);
  }
  return _react2['default'].createElement('script', { src: path });
}

function CSSBundle(_ref2) {
  var path = _ref2.path;

  if (!path) {
    return _react2['default'].createElement('noscript', null);
  }
  return _react2['default'].createElement('link', { rel: 'stylesheet', href: path });
}

function StartSite(_ref3) {
  var path = _ref3.path;

  if (!path) {
    return _react2['default'].createElement('noscript', null);
  }
  var __html = '\n    SitegenSite.renderIntoDocument().then(\n      function() { /* OK */ },\n      function(err) { throw err; }\n    );\n  ';
  return _react2['default'].createElement('script', { dangerouslySetInnerHTML: { __html: __html } });
}
module.exports = exports['default'];
