'use strict';

var _extends = require('babel-runtime/helpers/extends')['default'];

var _regeneratorRuntime = require('babel-runtime/regenerator')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = createSite;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _reactRouter = require('react-router');

var _historyLibCreateBrowserHistory = require('history/lib/createBrowserHistory');

var _historyLibCreateBrowserHistory2 = _interopRequireDefault(_historyLibCreateBrowserHistory);

var _RenderRoot = require('./RenderRoot');

var _RenderRoot2 = _interopRequireDefault(_RenderRoot);

var _createPage = require('./createPage');

var _createPage2 = _interopRequireDefault(_createPage);

var _utilRoute = require('./util/Route');

var _LinkRegistry = require('./LinkRegistry');

var _LinkRegistry2 = _interopRequireDefault(_LinkRegistry);

var _PageRegistry = require('./PageRegistry');

var _PageRegistry2 = _interopRequireDefault(_PageRegistry);

var _Meta = require('./Meta');

var _Meta2 = _interopRequireDefault(_Meta);

function createSite(spec, key) {
  var routes = _extends({}, (0, _createPage2['default'])(spec, key), {

    getRenderedMeta: function getRenderedMeta() {
      return _Meta2['default'].rewind() || {};
    }
  });

  routes.renderIntoDocument = function callee$1$0() {
    var element = arguments.length <= 0 || arguments[0] === undefined ? _RenderRoot2['default'].getDOMNode() : arguments[0];
    var flatRoutes, history, unlisten;
    return _regeneratorRuntime.async(function callee$1$0$(context$2$0) {
      while (1) switch (context$2$0.prev = context$2$0.next) {
        case 0:
          if (!(!_PageRegistry2['default'].installed() || !_LinkRegistry2['default'].installed())) {
            context$2$0.next = 6;
            break;
          }

          context$2$0.next = 3;
          return _regeneratorRuntime.awrap((0, _utilRoute.collectRoutes)(routes));

        case 3:
          flatRoutes = context$2$0.sent;

          _PageRegistry2['default'].createFromRoutes(flatRoutes).install();
          _LinkRegistry2['default'].createFromRoutes(flatRoutes).install();

        case 6:
          history = (0, _reactRouter.useRoutes)(_historyLibCreateBrowserHistory2['default'])({ routes: [routes] });
          unlisten = history.listen(function (err, _ref) {
            var location = _ref.location;

            if (err) {
              throw err;
            }
            (0, _reactRouter.match)({ routes: routes, location: location }, function (err, redirect, props) {
              return _reactDom2['default'].render(_react2['default'].createElement(_reactRouter.RoutingContext, _extends({}, props, { history: history })), element);
            });
          });
          return context$2$0.abrupt('return', function unmount() {
            unlisten();
            _reactDom2['default'].unmountComponentAtNode(element);
          });

        case 9:
        case 'end':
          return context$2$0.stop();
      }
    }, null, this);
  };

  return routes;
}

module.exports = exports['default'];
