'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.wrapPageModule = wrapPageModule;
exports.wrapPageContext = wrapPageContext;
exports.wrapPageLinkModule = wrapPageLinkModule;
exports.wrapPageLinkContext = wrapPageLinkContext;
exports.wrapPageMetaModule = wrapPageMetaModule;
exports.wrapPageMetaContext = wrapPageMetaContext;

var _LinkRegistry = require('./LinkRegistry');

var _LinkRegistry2 = _interopRequireDefault(_LinkRegistry);

var _PageRegistry = require('./PageRegistry');

var _PageRegistry2 = _interopRequireDefault(_PageRegistry);

var _utilArray = require('./util/Array');

var _createPage2 = require('./createPage');

var _createPage3 = _interopRequireDefault(_createPage2);

exports.createPage = _createPage3['default'];

var _createSite2 = require('./createSite');

var _createSite3 = _interopRequireDefault(_createSite2);

exports.createSite = _createSite3['default'];

function wrapPageModule(module) {
  return module;
}

function wrapPageContext(context) {
  return context;
}

function wrapPageLinkModule(module) {
  if (module.__sitegetLink === undefined) {
    var registry = _LinkRegistry2['default'].resolve();
    module.__sitegetLink = registry.get(module.id);
  }
  return module.__sitegetLink;
}

function wrapPageLinkContext(context) {
  if (module.__sitegetLink === undefined) {
    var items = context.keys().map(function (key) {
      return wrapPageLinkModule(context(key));
    });
    items = (0, _utilArray.uniqueBy)(items);
    module.__sitegetLink = items;
  }
  return module.__sitegetLink;
}

function wrapPageMetaModule(module) {
  if (module.__sitegenPage === undefined) {
    var registry = _PageRegistry2['default'].resolve();
    module.__sitegenPage = registry.get(module.id);
  }
  return module.__sitegenPage;
}

function wrapPageMetaContext(context) {
  if (module.__sitegenPage === undefined) {
    var items = context.keys().map(function (key) {
      return wrapPageMetaModule(context(key));
    });
    items = (0, _utilArray.uniqueBy)(items, function (item) {
      return item.path;
    });
    module.__sitegenPage = items;
  }
  return module.__sitegenPage;
}
