'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.uniqueBy = uniqueBy;

var _emptyFunctionThatReturnsArgument = require('empty/functionThatReturnsArgument');

var _emptyFunctionThatReturnsArgument2 = _interopRequireDefault(_emptyFunctionThatReturnsArgument);

/**
 * Filter `array` for dups by key provided by `keyFunc`.
 */

function uniqueBy(array) {
  var keyFunc = arguments.length <= 1 || arguments[1] === undefined ? _emptyFunctionThatReturnsArgument2['default'] : arguments[1];

  var seen = {};
  var result = [];
  for (var i = 0; i < array.length; i++) {
    var item = array[i];
    var key = keyFunc(item);
    if (!seen[key]) {
      seen[key] = true;
      result.push(item);
    }
  }
  return result;
}
