'use strict';

var _extends = require('babel-runtime/helpers/extends')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.listFormatter = listFormatter;
exports.parse = parse;
exports.configure = configure;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _packageJson = require('../../package.json');

var _packageJson2 = _interopRequireDefault(_packageJson);

var _webpackConfigure = require('../webpack/configure');

var _webpackConfigure2 = _interopRequireDefault(_webpackConfigure);

function listFormatter() {
  var items = arguments.length <= 0 || arguments[0] === undefined ? [] : arguments[0];

  return function (item) {
    items.push(item);
    return items;
  };
}

function parse(argv) {
  var configure = arguments.length <= 1 || arguments[1] === undefined ? null : arguments[1];

  var parser = _commander2['default'].version(_packageJson2['default'].version).usage('sitegen-serve [options] <site>').description('Serve site').option('-L, --lib <directory>', 'site library directory (default: $site/lib)').option('-r, --require <entry>', 'additional entry to require', listFormatter(), []);

  if (configure) {
    parser = configure(parser);
  }

  var options = parser.parse(process.argv);

  var cwd = process.cwd();
  var site = _path2['default'].join(cwd, options.args[0] || '.');

  return {
    site: site,
    options: _extends({}, options, {
      output: options.output ? _path2['default'].join(cwd, options.output) : options.output,
      lib: options.lib ? _path2['default'].join(cwd, options.lib) : options.lib,
      require: options.require.map(function (item) {
        return _path2['default'].join(cwd, item);
      })
    })
  };
}

var siteLoader = require.resolve('../webpack/loader/site');

function makeSiteEntry(entry, options) {
  options = JSON.stringify(options);
  return siteLoader + '?' + options + '!' + entry;
}

function configure(site, options) {
  var relativize = function relativize(p) {
    return _path2['default'].join(_path2['default'].dirname(site), p);
  };
  var entry = [].concat(options.require).concat(makeSiteEntry(site, { content: site, asContext: false })).filter(Boolean);
  var lib = options.lib || relativize('lib');
  var output = options.output || relativize('output');
  return (0, _webpackConfigure2['default'])(_extends({}, options, { entry: entry, lib: lib, output: output }));
}
