"use strict";

var _Promise = require("babel-runtime/core-js/promise")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.awaitCallback = awaitCallback;
exports.forEachSeq = forEachSeq;

function awaitCallback(func) {
  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  return new _Promise(function (resolve, reject) {
    args.push(function (error, result) {
      if (error) {
        reject(error);
      } else {
        resolve(result);
      }
    });
    func.apply(null, args);
  });
}

function forEachSeq(array, func) {
  var promise = _Promise.resolve();
  array.forEach(function (item) {
    return promise = promise.then(function () {
      return func(item);
    });
  });
  return promise;
}
