'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var LogProgressPlugin = (function () {
  function LogProgressPlugin() {
    var name = arguments.length <= 0 || arguments[0] === undefined ? 'webpack' : arguments[0];

    _classCallCheck(this, LogProgressPlugin);

    this.name = name;
    this._logger = (0, _debug2['default'])('sitegen:compiler:' + name);
    this._notifyOnCompile = true;
  }

  _createClass(LogProgressPlugin, [{
    key: 'apply',
    value: function apply(compiler) {
      compiler.plugin('compile', this._onCompile.bind(this));
      compiler.plugin('invalid', this._onInvalid.bind(this));
      compiler.plugin('done', this._onDone.bind(this));
    }
  }, {
    key: '_onDone',
    value: function _onDone(stats) {
      var _this = this;

      if (stats.compilation.errors.length > 0) {
        this._logger('compilation failed');
        stats.compilation.errors.forEach(function (error) {
          return _this._logger(error.message);
        });
      } else {
        this._logger('compilation finished');
      }
    }
  }, {
    key: '_onCompile',
    value: function _onCompile() {
      if (this._notifyOnCompile) {
        this._notifyOnCompile = false;
        this._logger('compilation started');
      }
    }
  }, {
    key: '_onInvalid',
    value: function _onInvalid() {
      this._logger('bundled invalidated, recompiling...');
    }
  }]);

  return LogProgressPlugin;
})();

exports['default'] = LogProgressPlugin;
module.exports = exports['default'];
