'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _extends = require('babel-runtime/helpers/extends')['default'];

var _Promise = require('babel-runtime/core-js/promise')['default'];

var _Object$keys = require('babel-runtime/core-js/object/keys')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _eval = require('eval');

var _eval2 = _interopRequireDefault(_eval);

var _historyLibCreateLocation = require('history/lib/createLocation');

var _historyLibCreateLocation2 = _interopRequireDefault(_historyLibCreateLocation);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouter = require('react-router');

var _reactDomServer = require('react-dom/server');

var _Site = require('../Site');

var _Site2 = _interopRequireDefault(_Site);

var _utilRoute = require('../util/Route');

var _utilPromise = require('../util/Promise');

var _LinkRegistry = require('../LinkRegistry');

var _LinkRegistry2 = _interopRequireDefault(_LinkRegistry);

var _PageRegistry = require('../PageRegistry');

var _PageRegistry2 = _interopRequireDefault(_PageRegistry);

var _configure = require('./configure');

var RenderStaticPlugin = (function () {
  function RenderStaticPlugin() {
    _classCallCheck(this, RenderStaticPlugin);
  }

  _createClass(RenderStaticPlugin, [{
    key: 'apply',
    value: function apply(compiler) {
      var _this = this;

      compiler.plugin('emit', function (compilation, done) {
        var bundle = compilation.assets[_configure.JS_BUNDLE_NAME];
        var source = bundle._source ? bundle._source.source() : bundle.source();
        var window = {};
        var scope = {
          console: console,
          process: process,
          setTimeout: setTimeout,
          window: window
        };
        var routes = (0, _eval2['default'])('module.exports = ' + source, '<bootstrap>', scope);

        cleanAssets(compilation.assets);

        function addToAssets(path, markup) {
          compilation.assets[routePathToAssetPath(path)] = createAssetFromContents(markup);
        }

        var collectedRoutes = (0, _utilRoute.collectRoutes)(routes);

        collectedRoutes.then(function (childRoutes) {
          var linkRegistry = _LinkRegistry2['default'].createFromRoutes(childRoutes);
          var pageRegistry = _PageRegistry2['default'].createFromRoutes(childRoutes);
          linkRegistry.install(window);
          pageRegistry.install(window);
          return (0, _utilPromise.forEachSeq)(childRoutes, function (route) {
            return _this.renderPath(routes, route.path, { linkRegistry: linkRegistry, pageRegistry: pageRegistry }).then(addToAssets.bind(null, route.path));
          });
        }).then(function () {
          done();
        }, function (err) {
          compilation.errors.push(err);
          done(err);
        });
      });
    }
  }, {
    key: 'renderPath',
    value: function renderPath(routes, path, siteProps) {
      return new _Promise(function (resolve, reject) {
        var location = (0, _historyLibCreateLocation2['default'])(path);
        (0, _reactRouter.match)({ routes: routes, location: location }, function (error, redirectLocation, routeProps) {
          if (error) {
            reject(error);
          } else {
            var innerMarkup = (0, _reactDomServer.renderToString)(_react2['default'].createElement(_reactRouter.RoutingContext, routeProps));

            var _routes$getRenderedMeta = routes.getRenderedMeta();

            var title = _routes$getRenderedMeta.title;
            var meta = _routes$getRenderedMeta.meta;
            var link = _routes$getRenderedMeta.link;

            var markup = (0, _reactDomServer.renderToStaticMarkup)(_react2['default'].createElement(
              _Site2['default'],
              _extends({
                title: title,
                meta: meta,
                link: link,
                jsBundlePath: '/' + _configure.JS_BUNDLE_NAME,
                cssBundlePath: '/' + _configure.CSS_BUNDLE_NAME
              }, siteProps),
              innerMarkup
            ));
            resolve(markup);
          }
        });
      });
    }
  }]);

  return RenderStaticPlugin;
})();

exports['default'] = RenderStaticPlugin;

function createAssetFromContents(contents) {
  return {
    source: function source() {
      return contents;
    },
    size: function size() {
      return contents.length;
    }
  };
}

function routePathToAssetPath(path) {
  path = path.replace(/^\//, '').replace(/\/$/, '');
  return path + '/index.html';
}

function cleanAssets(assets) {
  _Object$keys(assets).forEach(function (key) {
    return delete assets[key];
  });
}
module.exports = exports['default'];
