'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

var _loaderUtils = require('loader-utils');

var _loaderUtils2 = _interopRequireDefault(_loaderUtils);

var _resourceID = require('../../resourceID');

var _resourceID2 = _interopRequireDefault(_resourceID);

var bundleLoader = require.resolve('bundle-loader');

module.exports = function (source) {
  if (this.cacheable) {
    this.cacheable();
  }
  var key = JSON.stringify((0, _resourceID2['default'])(this.resource));
  source = '\n    ' + source + ';\n    module.exports = require(\'sitegen/internal\').createPage(module.exports, ' + key + ');\n  ';
  return source;
};

module.exports.pitch = function (remainingRequest) {
  if (this.cacheable) {
    this.cacheable();
  }
  var query = _loaderUtils2['default'].parseQuery(this.query);
  var options = this.options.sitegen;

  if (query.wrap) {
    return undefined;
  } else if (options.mode === 'serve' && !options.dev) {
    var request = _loaderUtils2['default'].stringifyRequest(this, '!!' + bundleLoader + '?name=[path][name]!' + __filename + '?wrap!' + remainingRequest);
    return 'module.exports = require(' + request + ');';
  } else {
    return undefined;
  }
};
