'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

var _loaderUtils = require('loader-utils');

var _loaderUtils2 = _interopRequireDefault(_loaderUtils);

var _resourceID = require('../../resourceID');

var _resourceID2 = _interopRequireDefault(_resourceID);

function normalizePath(path) {
  if (path[0] === '/') {
    return path;
  } else {
    return './' + path;
  }
}

module.exports = function () {
  if (this.cacheable) {
    this.cacheable();
  }
  var options = _loaderUtils2['default'].parseQuery(this.query);
  var key = JSON.stringify((0, _resourceID2['default'])(this.resource));
  if (options.asContext) {
    return '\n      module.exports = require(\'sitegen/internal\').createSite({\n        path: \'/\',\n        route: require.context(\n          \'page!' + normalizePath(options.content) + '\',\n          true,\n          /.+/)\n      }, ' + key + ');\n    ';
  } else {
    return '\n      module.exports = require(\'sitegen/internal\').createSite({\n        path: \'/\',\n        route: require(\'page!' + normalizePath(options.content) + '\')\n      }, ' + key + ');\n    ';
  }
};
